rm(list=ls())

library(MASS)

source("funkce.R")

fixings = c("22/11/2017", "23/10/2018")    
maturity = "31/10/2018"
NITER = 10000
bonus = 1.05
level = 0.6
calcDate = "27/04/2018"

##################################################################################################################################


    discount = read.csv("CZK_A_D_27.4.2018.txt", header=FALSE, sep=";", dec=",")
    discount[,1] = discount[,1]/365
    discount[,2] = discount[,2]/100


    driftcurve = read.csv("EUR_DRIFT_27.4.2018.txt", header=FALSE, sep=";", dec=",")
    driftcurve = cbind(driftcurve, driftcurve[2])
    driftcurve = cbind(driftcurve, driftcurve[2])
    
    driftcurve[,1] = driftcurve[,1]/365
    driftcurve[,2:4] = driftcurve[,2:4]/100


    historie = read.csv("Basket.txt", header=FALSE, sep=";", row.names=1, dec=",")
    
    STRIKE = c(45.41, 51.88, 48.365)
    spotprice = c(44.02, 51.56, 44.37)/STRIKE
    dividend = c(3.59, 3.014, 2.395)/100


    volatility = VolatilityMatrix(historie[1:360,], Lambda=0.98)[3,] # EWMA
    #volatility = VolatilityMatrix(historie[1:360,], Lambda=0.96)[2,] # historicka
    #volatility = c(0.24514, 0.23642, 0.24237)
    
    correlation = CorrelationMatrix(historie)
    niter = NITER

    seed = 1

  
##################################
  
  datmax = fixings[2] 


  NbOfOpt = DateDiff(calcDate, datmax)+ 1   
  OptionDates = CreateCalendar(calcDate, NbOfOpt, 1, "day", "string", "ModPrec")[-1]    
  UniqOptDates = unique(OptionDates)
  TimeToDates = 1:length(UniqOptDates)/260   

  mSimulationPath = EqGen(spotPrice=spotprice, dividendReturn=dividend, corr=correlation,nSim=niter, 
                          times=TimeToDates, curv=driftcurve, sigma=volatility, seed=seed)
  
  dimnames(mSimulationPath) = list(c("Andritz","OMV","voestalpine"), NULL, c(calcDate, UniqOptDates))



   FutureDays = min(DateDiff(calcDate, fixings[2]), length(UniqOptDates))
   
   future = mSimulationPath[,,UniqOptDates] 


    # SPOCITANI VYSLEDKU
    timeToMat = DateDiff(calcDate, maturity)/365
    DF = (1 + splinefun(discount)(timeToMat))^(-timeToMat)

   
      minim = apply(future,1,min)
      pod = minim <= level
      nad = minim > level
      future[pod,,FutureDays] = future[pod,,FutureDays] + (bonus - 1)
      future[nad,,FutureDays] = bonus
      FinalValues = future[,,FutureDays]
      RedemptionPrice = mean(pmin(FinalValues,bonus))
    


    CleanPrice = RedemptionPrice * DF        
    CleanPrice