rm(list=ls())

library(MASS)


source("funkce.R")



NITER = 10000
COUPONS = 1:5*rep(0.04,5)
LEVELS = c(1, 1, 1, 1, 0.60)
FIXDATES = c("24/09/2018", "23/09/2019", "22/09/2020","22/09/2021", "22/09/2022")
MATURITY = "29/09/2022"




  calcDate = "24/07/2018"

  
  # nacteni krivek
    discountA = read.csv("EUR_A_D_27.4.2018.txt", header=FALSE, sep=";")
    discountA[,1] = discountA[,1]/365
    discountA[,2] = discountA[,2]/100
    
    discountAA = read.csv("EUR_AA_D_27.4.2018.txt", header=FALSE, sep=";")
    discountAA[,1] = discountAA[,1]/365
    discountAA[,2] = discountAA[,2]/100    

    discountBBB = read.csv("EUR_BBB_D_27.4.2018.txt", header=FALSE, sep=";")
    discountBBB[,1] = discountBBB[,1]/365
    discountBBB[,2] = discountBBB[,2]/100

    driftcurve = read.csv("EUR_DRIFT_27.4.2018.txt", header=FALSE, sep=";", dec=",")
    driftcurve = cbind(driftcurve, driftcurve[2])
    driftcurve[,1] = driftcurve[,1]/365
    driftcurve[,2:3] = driftcurve[,2:3]/100

    

  historie = read.csv("Eurostoxx_history.txt", header=FALSE, sep=";", row.names=1, dec=",")
  historie[,2]=historie[,1]
    
    STRIKE = 3563.64
    spotprice = rep(3518.78/STRIKE,2)
    dividend = 3.51114/100
  


   

    #volatility = VolatilityMatrix(historie[1:90,], Lambda=0.96)[3,] # EWMA
    volatility = VolatilityMatrix(historie[1:720,], Lambda=0.98)[2,] # historicka
    #volatility = 0.1148 
    
    correlation = CorrelationMatrix(historie)
    niter = NITER

   names(LEVELS)=FIXDATES
   TimeToFix = DateDiff(calcDate, FIXDATES)/365
   TimeToPay = DateDiff(calcDate, MATURITY)/365
   FutDays = FIXDATES[which(TimeToFix>0)]
   LEVELS = LEVELS[FutDays]    
   Coup = COUPONS
   names(Coup) = FIXDATES
   Coup = Coup[FutDays]     
   TimeToFix = TimeToFix[TimeToFix>=0]  
  
   mSimulationPath = EqGen(spotPrice=spotprice, dividendReturn=dividend, corr=correlation,
                          nSim=niter, times=TimeToFix, curv=driftcurve, sigma=volatility, seed=1)[,,-1]

 

##################################################################################################################################


  dim(mSimulationPath)
  if (length(dim(mSimulationPath))==3) {
    mSimulationPath = mSimulationPath[1,,]
  } else {
    mSimulationPath = mSimulationPath[1,]
  }

  indik = t(t(mSimulationPath)>LEVELS)
  colnames(indik) = FutDays
 
    indikOVER = t(apply(t(apply(indik,1,cumsum)),1,cumsum))==1  # prvni vyskyt hodnoty vetsi nez bariera v danem obdobi
    CoupProb = apply(indikOVER,2,mean)                          # pravdepodobnost vyplaty kuponu v jednotlivych dni pozorovani 

    
  CoupProb[length(CoupProb)+1] = 1 - sum(CoupProb)              # pravdepodobnost vyplaty na konci za cenu pod barierou
  names(CoupProb) = c(FutDays,FutDays[length(FutDays)])
     
  indikUNDER = apply(indik, 1, max)
  indikUNDER = -1* (indikUNDER - 1)
  if(length(FutDays)>1) {
    PerfFinal = mSimulationPath[,length(TimeToFix)] - 1
  } else {
    PerfFinal = mSimulationPath - 1   
  }    
  PerfFinal = PerfFinal[which(indikUNDER==1)]
  PerfFinal = mean(PerfFinal)
  names(PerfFinal) = FutDays[length(FutDays)] 
  
  if (is.na(PerfFinal)) {
    PerfFinal = 0
  } 
     
  Coup = c(Coup, PerfFinal)
  
  
  ProbAA = 0.0078*TimeToFix
  ProbBBB = 0.0391*TimeToFix
  ProbA = 1-ProbAA-ProbBBB
  
  
  
  DFA = (1 + splinefun(discountA)(TimeToFix))^(-TimeToFix)
  DFAA = (1 + splinefun(discountAA)(TimeToFix))^(-TimeToFix)
  DFBBB = (1 + splinefun(discountBBB)(TimeToFix))^(-TimeToFix)
  
  DF = DFA*ProbA + DFAA*ProbAA + DFBBB*ProbBBB
  
  DF[length(DF)+1] = DF[length(DF)]
  names(DF) = c(FutDays,FutDays[length(FutDays)])


  optionS = CoupProb * DF * Coup  
  option = sum(optionS)

  zeroS = CoupProb * DF
  zero = sum(zeroS)

 
    TotalStructure = option + zero
    
    TotalStructure
